Index: /trunk/src/pvoconesearch.cc
===================================================================
--- /trunk/src/pvoconesearch.cc	(revision 57)
+++ /trunk/src/pvoconesearch.cc	(revision 58)
@@ -22,5 +22,5 @@
   2. pvoconesearch -h\n\
 ---------\n\
-  1. Prints RA, DEC, DATE-OBS, BEAMSIZE, OFFSET for all FITS files that\n\
+  1. Prints RA, DEC, BEAM FWHM, DATE-OBS, OFFSET for all FITS files that\n\
      lie within \"radius\" of the position given by ra, dec.\n\
      OFFSET is angular offset from query position.\n\
@@ -83,5 +83,5 @@
   }
 
-  int maxsize = 0;
+  int maxsize = 8; // size of "FILENAME"
   for(i=0;i<namelist.size();i++) 
     maxsize = std::max(maxsize,int(namelist[i].size()));
@@ -93,13 +93,13 @@
 	    << std::setw(14)      << "RA"        << " "
 	    << std::setw(14)      << "DEC"       << " "
+	    << std::setw(10)      << "BEAM FWHM"  << " "
 	    << std::setw(30)      << "DATE-OBS"  << " "
-	    << std::setw(10)      << "BEAM FWHM"  << " "
 	    << std::setw(12)      << "OFFSET"    << "\n"
 	    << std::setw(maxsize) << ""          << "  "
 	    << std::setw(14)      << ""          << " "
 	    << std::setw(14)      << ""          << " "
+	    << std::setw(10)      << "[deg]"     << " "
 	    << std::setw(30)      << ""          << " "
-	    << std::setw(10)      << "[arcmin]"  << " "
-	    << std::setw(12)      << "[arcmin]"  << "\n"
+	    << std::setw(12)      << "[deg]"     << "\n"
 	    << std::setfill('-')  
 	    << std::setw(maxsize+1+15+15+31+11+13) << "-"
@@ -120,8 +120,8 @@
       if(fitsfile.getKeyword<std::string>("DEC",dec)!=0) dec = missing;
       if(fitsfile.getKeyword<std::string>("DATE-OBS",date)!=0) date = missing;
-      float beamradius,bmaj,bmin;
+      float beamfwhm,bmaj,bmin;
       fitsfile.getKeyword<float>("BMAJ",bmaj);
       fitsfile.getKeyword<float>("BMIN",bmin);
-      beamradius = 0.5*(bmaj+bmin)/2.; // half average FWHM, in deg
+      beamfwhm = 0.5*(bmaj+bmin); // average FWHM, in deg
 
       if(ra!=missing && dec!=missing){
@@ -129,11 +129,11 @@
 			       RAcentre,        DECcentre     );
 
-	if(angsep < radius+beamradius)
+	if(angsep < radius+beamfwhm/2.)
 	  std::cout << std::setw(maxsize) << namelist[i] << ": "
 		    << std::setw(14)      << ra          << " "
 		    << std::setw(14)      << dec         << " "
+		    << std::setw(10)      << beamfwhm    << " "
 		    << std::setw(30)      << date        << " "
-		    << std::setw(10)      << beamradius*2.<< " "
-		    << std::setw(12)      << angsep*60.  << "\n";
+		    << std::setw(12)      << angsep      << "\n";
       
       }
Index: /trunk/src/pvosummary.cc
===================================================================
--- /trunk/src/pvosummary.cc	(revision 57)
+++ /trunk/src/pvosummary.cc	(revision 58)
@@ -23,6 +23,6 @@
   3. pvosummary -h\n\
 ---------\n\
-  1. Prints RA, DEC, DATE-OBS for single FITS file.\n\
-  2. Prints RA, DEC, DATE-OBS for all fits files in the current directory.\n\
+  1. Prints RA, DEC, BEAM FWHM, DATE-OBS for single FITS file.\n\
+  2. Prints RA, DEC, BEAM FWHM, DATE-OBS for all FITS files in the current directory.\n\
   3. Prints this help information.\n\
  Note that if a keyword is not present, --- is printed.\n\
@@ -63,16 +63,23 @@
   }
 
-  int maxsize = 0;
+  int maxsize = 8; // size of "FILENAME"
   for(i=0;i<namelist.size();i++) 
     maxsize = std::max(maxsize,int(namelist[i].size()));
 
-  std::cout << std::setfill('-')  << std::setw(maxsize+1+15+15+31) << ""
+  std::cout << std::setfill('-')  
+	    << std::setw(maxsize+1+15+15+31+11) << "-"
 	    << "\n" << std::setfill(' ') 
 	    << std::setw(maxsize) << "FILENAME"  << ": "
 	    << std::setw(14)      << "RA"        << " "
 	    << std::setw(14)      << "DEC"       << " "
+	    << std::setw(10)      << "BEAM FWHM" << " "
 	    << std::setw(30)      << "DATE-OBS"  << "\n"
+	    << std::setw(maxsize) << ""          << "  "
+	    << std::setw(14)      << ""          << " "
+	    << std::setw(14)      << ""          << " "
+	    << std::setw(10)      << "[deg]"     << " "
+	    << std::setw(30)      << ""          << "\n"
 	    << std::setfill('-')  
-	    << std::setw(maxsize+1+15+15+31) << ""
+	    << std::setw(maxsize+1+15+15+31+11) << "-"
 	    << "\n"<< std::setfill(' ') ;
 
@@ -91,9 +98,14 @@
       if(fitsfile.getKeyword<std::string>("DEC",dec)!=0) dec = missing;
       if(fitsfile.getKeyword<std::string>("DATE-OBS",date)!=0) date = missing;
+      float beamradius,bmaj,bmin;
+      fitsfile.getKeyword<float>("BMAJ",bmaj);
+      fitsfile.getKeyword<float>("BMIN",bmin);
+      beamradius = 0.5*(bmaj+bmin); // average FWHM, in deg
     
-      std::cout << std::setw(maxsize) << namelist[i] << ": "
-		<< std::setw(14)      << ra          << " "
-		<< std::setw(14)      << dec         << " "
-		<< std::setw(30)      << date        << "\n";
+      std::cout << std::setw(maxsize) << namelist[i]  << ": "
+		<< std::setw(14)      << ra           << " "
+		<< std::setw(14)      << dec          << " "
+		<< std::setw(10)      << beamradius   << " "
+		<< std::setw(30)      << date         << "\n";
     }
   }