Index: /trunk/src/pvo-utils.hh
===================================================================
--- /trunk/src/pvo-utils.hh	(revision 63)
+++ /trunk/src/pvo-utils.hh	(revision 64)
@@ -12,18 +12,21 @@
 "Usage: pvoconvert [options] <survey file>\n\
   Options:\n\
-  -H  Use the PH (High Latitude) Survey settings, rather than the PM/Multibeam Survey\n\
+  -H  Use the PH (High Latitude) Survey settings, rather than those for the\n\
+       PM/Multibeam Survey\n\
   -h  Display this help page.\n\
   -v  Verbose mode for error/warning messages.\n\
 ---------\n\n\
  PVOConvert converts pulsar survey data into PSRFITS format.\n\
- It can distinguish between the 70cm data and 21cm Multibeam data, but to specify\n\
-  particular data as coming from the High Latitude survey rather than the standard\n\
-  Multibeam survey, use the -h option.\n\
- Output files will be encoded according to the survey and date & time of observation.\n";
+ It can distinguish between the 70cm data and 21cm Multibeam data, but to\n\
+  specify particular data as coming from the High Latitude survey rather\n\
+  than the standard Multibeam survey, use the -h option.\n\
+ Output files will be encoded according to the survey type and date & time\n\
+  of observation.\n";
   /** Brief help text for pvoconvert -h */
   const std::string pvoconvert_usage_text_short = 
 "Usage: pvoconvert [options] <survey file>\n\
   Options:\n\
-  -H  Use the PH (High Latitude) Survey settings, rather than the PM/Multibeam Survey\n\
+  -H  Use the PH (High Latitude) Survey settings, rather than those for the\n\
+       PM/Multibeam Survey\n\
   -h  Display the help page.\n\
   -v  Verbose mode for error/warning messages.\n";
@@ -36,6 +39,7 @@
   3. pvosummary -h\n\
 ---------\n\
-  1. Prints RA, DEC, BEAM FWHM, DATE-OBS for single FITS file.\n\
-  2. Prints RA, DEC, BEAM FWHM, DATE-OBS for all FITS files in the current directory.\n\
+  1. Prints RA, DEC, BEAM FWHM, OBSFREQ, DATE-OBS for single FITS file.\n\
+  2. Prints RA, DEC, BEAM FWHM, OBSFREQ, DATE-OBS for all FITS files in the\n\
+      current directory.\n\
   3. Prints this help information.\n\
  Note that if a keyword is not present, --- is printed.\n\
@@ -54,10 +58,10 @@
   2. pvoconesearch -h\n\
 ---------\n\
-  1. Prints RA, DEC, BEAM FWHM, DATE-OBS, OFFSET for all FITS files that\n\
-     lie within \"radius\" of the position given by ra, dec.\n\
+  1. Prints RA, DEC, BEAM FWHM, OBSFREQ, DATE-OBS, OFFSET for all FITS files\n\
+     that lie within \"radius\" of the position given by ra, dec.\n\
      OFFSET is angular offset from query position.\n\
   2. Prints this help information.\n\n\
- The valid files are listed in order of increasing angular separation from the\n\
-  query position.\n\
+ The valid files are listed in order of increasing angular separation from\n\
+  the query position.\n\
  The RA and DEC can be in the form hh:mm:ss.ss etc or in decimal degrees.\n\
  The search radius is in degrees. The beam size is also taken into account,\n\
Index: /trunk/src/pvoconesearch.cc
===================================================================
--- /trunk/src/pvoconesearch.cc	(revision 63)
+++ /trunk/src/pvoconesearch.cc	(revision 64)
@@ -27,6 +27,6 @@
   };
   void define(std::string n, double r, double d, std::string t,
-	      float b, float a){
-    name=n; ra=r; dec=d; date=t; beam=b; angsep=a;
+	      float b, std::string f, float a){
+    name=n; ra=r; dec=d; date=t; beam=b; obsfreq=f; angsep=a;
   }
   std::string name;
@@ -35,4 +35,5 @@
   std::string date;
   float beam;
+  std::string obsfreq;
   float angsep;
 };
@@ -58,10 +59,10 @@
    *
    * The output is a list of valid files, their central RA & DEC,
-   * their beam size, the DATE-OBS keyword (time/date of observation),
-   * plus the angular offset [deg] from the query position. The beam
-   * size of the FITS file is taken into account, so that the central
-   * position can be more than RADIUS away from the query position (as
-   * long as the query position is still within the primary beam's
-   * FWHM).
+   * their beam size, the central observing frequency, the DATE-OBS
+   * keyword (time/date of observation), plus the angular offset [deg]
+   * from the query position. The beam size of the FITS file is taken
+   * into account, so that the central position can be more than
+   * RADIUS away from the query position (as long as the query
+   * position is still within the primary beam's FWHM).
    * 
    */
@@ -116,28 +117,4 @@
   }
 
-  int maxsize = 8; // size of "FILENAME"
-  for(i=0;i<namelist.size();i++) 
-    maxsize = std::max(maxsize,int(namelist[i].size()));
-
-  std::cout << std::setfill('-')  
-	    << std::setw(maxsize+1+15+15+31+11+13) << "-"
-	    << "\n" << std::setfill(' ') 
-	    << std::setw(maxsize) << "FILENAME"  << ": "
-	    << std::setw(14)      << "RA"        << " "
-	    << std::setw(14)      << "DEC"       << " "
-	    << std::setw(10)      << "BEAM FWHM"  << " "
-	    << std::setw(30)      << "DATE-OBS"  << " "
-	    << std::setw(12)      << "OFFSET"    << "\n"
-	    << std::setw(maxsize) << ""          << "  "
-	    << std::setw(14)      << "[deg]"     << " "
-	    << std::setw(14)      << "[deg]"     << " "
-	    << std::setw(10)      << "[deg]"     << " "
-	    << std::setw(30)      << ""          << " "
-	    << std::setw(12)      << "[deg]"     << "\n"
-	    << std::setfill('-')  
-	    << std::setw(maxsize+1+15+15+31+11+13) << "-"
-	    << "\n"<< std::setfill(' ') ;
-
-  
   std::vector<Match> goodlist;
 
@@ -151,9 +128,10 @@
       fitsfile.gotoPHU();
     
-      std::string raS,decS,date;
+      std::string raS,decS,date,obsfreqS;
       std::string missing = "---";
       if(fitsfile.getKeyword<std::string>("RA",raS)!=0) raS = missing;
       if(fitsfile.getKeyword<std::string>("DEC",decS)!=0) decS = missing;
       if(fitsfile.getKeyword<std::string>("DATE-OBS",date)!=0) date = missing;
+      if(fitsfile.getKeyword<std::string>("OBSFREQ",obsfreqS)!=0) obsfreqS = missing;
       float beamfwhm,bmaj,bmin;
       fitsfile.getKeyword<float>("BMAJ",bmaj);
@@ -169,5 +147,5 @@
 	if(angsep < radius+beamfwhm/2.) {
 	  Match newmatch;
-	  newmatch.define(namelist[i],ra,dec,date,beamfwhm,angsep);
+	  newmatch.define(namelist[i],ra,dec,date,beamfwhm,obsfreqS,angsep);
 	  goodlist.push_back(newmatch);
 	}
@@ -180,6 +158,31 @@
   std::stable_sort(goodlist.begin(),goodlist.end());
 
+  int maxsize = 8; // size of "FILENAME"
+  for(i=0;i<goodlist.size();i++) 
+    maxsize = std::max(maxsize,int(goodlist[i].name.size()));
+
+  std::cout << std::setfill('-')  
+	    << std::setw(maxsize+1+15+15+31+11+11+13) << "-"
+	    << "\n" << std::setfill(' ') 
+	    << std::setw(maxsize) << "FILENAME"  << " "
+	    << std::setw(14)      << "RA"        << " "
+	    << std::setw(14)      << "DEC"       << " "
+	    << std::setw(10)      << "BEAM FWHM" << " "
+	    << std::setw(10)      << "OBSFREQ"   << " "
+	    << std::setw(30)      << "DATE-OBS"  << " "
+	    << std::setw(12)      << "OFFSET"    << "\n"
+	    << std::setw(maxsize) << ""          << " "
+	    << std::setw(14)      << "[deg]"     << " "
+	    << std::setw(14)      << "[deg]"     << " "
+	    << std::setw(10)      << "[deg]"     << " "
+	    << std::setw(10)      << "[MHz]"     << " "
+	    << std::setw(30)      << ""          << " "
+	    << std::setw(12)      << "[deg]"     << "\n"
+	    << std::setfill('-')  
+	    << std::setw(maxsize+1+15+15+31+11+11+13) << "-"
+	    << "\n"<< std::setfill(' ') ;
+
   for(i=0;i<goodlist.size();i++){
-    std::cout << std::setw(maxsize) << goodlist[i].name    << ": "
+    std::cout << std::setw(maxsize) << goodlist[i].name    << " "
 	      << std::setprecision(6)
 	      << std::setw(14)      << goodlist[i].ra      << " "
@@ -187,4 +190,5 @@
 	      << std::setprecision(4)
 	      << std::setw(10)      << goodlist[i].beam    << " "
+	      << std::setw(10)      << goodlist[i].obsfreq << " "
 	      << std::setw(30)      << goodlist[i].date    << " "
 	      << std::setw(12)      << goodlist[i].angsep  << "\n";
Index: /trunk/src/pvosummary.cc
===================================================================
--- /trunk/src/pvosummary.cc	(revision 63)
+++ /trunk/src/pvosummary.cc	(revision 64)
@@ -36,6 +36,6 @@
    *
    * The output is a list of valid files, their central RA & DEC,
-   * their beam size, and the DATE-OBS keyword (time/date of
-   * observation),
+   * their beam size, the central observing frequency, and the
+   * DATE-OBS keyword (time/date of observation),
    * 
    */
@@ -78,18 +78,20 @@
 
   std::cout << std::setfill('-')  
-	    << std::setw(maxsize+1+15+15+31+11) << "-"
+	    << std::setw(maxsize+1+15+15+31+11+11) << "-"
 	    << "\n" << std::setfill(' ') 
-	    << std::setw(maxsize) << "FILENAME"  << ": "
+	    << std::setw(maxsize) << "FILENAME"  << " "
 	    << std::setw(14)      << "RA"        << " "
 	    << std::setw(14)      << "DEC"       << " "
 	    << std::setw(10)      << "BEAM FWHM" << " "
+	    << std::setw(10)      << "OBSFREQ"   << " "
 	    << std::setw(30)      << "DATE-OBS"  << "\n"
-	    << std::setw(maxsize) << ""          << "  "
+	    << std::setw(maxsize) << ""          << " "
 	    << std::setw(14)      << ""          << " "
 	    << std::setw(14)      << ""          << " "
 	    << std::setw(10)      << "[deg]"     << " "
+	    << std::setw(10)      << "[MHz]"     << " "
 	    << std::setw(30)      << ""          << "\n"
 	    << std::setfill('-')  
-	    << std::setw(maxsize+1+15+15+31+11) << "-"
+	    << std::setw(maxsize+1+15+15+31+11+11) << "-"
 	    << "\n"<< std::setfill(' ') ;
 
@@ -103,18 +105,20 @@
       fitsfile.gotoPHU();
     
-      std::string ra,dec,date;
+      std::string ra,dec,date,obsfreqS;
       std::string missing = "---";
       if(fitsfile.getKeyword<std::string>("RA",ra)!=0) ra = missing;
       if(fitsfile.getKeyword<std::string>("DEC",dec)!=0) dec = missing;
       if(fitsfile.getKeyword<std::string>("DATE-OBS",date)!=0) date = missing;
-      float beamradius,bmaj,bmin;
+      if(fitsfile.getKeyword<std::string>("OBSFREQ",obsfreqS)!=0) obsfreqS = missing;
+      float beamradius,bmaj,bmin,obsfreq;
       fitsfile.getKeyword<float>("BMAJ",bmaj);
       fitsfile.getKeyword<float>("BMIN",bmin);
       beamradius = 0.5*(bmaj+bmin); // average FWHM, in deg
-    
-      std::cout << std::setw(maxsize) << namelist[i]  << ": "
+
+      std::cout << std::setw(maxsize) << namelist[i]  << " "
 		<< std::setw(14)      << ra           << " "
 		<< std::setw(14)      << dec          << " "
 		<< std::setw(10)      << beamradius   << " "
+		<< std::setw(10)      << obsfreqS     << " "
 		<< std::setw(30)      << date         << "\n";
     }